"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var THREE = __importStar(require("three"));
var react_1 = __importStar(require("react"));
var fiber_1 = require("@react-three/fiber");
var drei_1 = require("@react-three/drei");
var valtio_1 = require("valtio");
var Minimap_1 = require("./utils/Minimap");
var util_1 = require("./utils/util");
var Item = function (_a) {
    var 
    // eslint-disable-next-line react/prop-types
    urls = _a.urls, 
    // eslint-disable-next-line react/prop-types
    index = _a.index, 
    // eslint-disable-next-line react/prop-types
    position = _a.position, 
    // eslint-disable-next-line react/prop-types
    scale = _a.scale, 
    // eslint-disable-next-line react/prop-types
    _b = _a.c, 
    // eslint-disable-next-line react/prop-types
    c = _b === void 0 ? new THREE.Color() : _b, props = __rest(_a, ["urls", "index", "position", "scale", "c"]);
    var ref = (0, react_1.useRef)();
    var scroll = (0, drei_1.useScroll)();
    var clicked = (0, valtio_1.useSnapshot)(util_1.state).clicked;
    var _c = (0, react_1.useState)(false), hovered = _c[0], hover = _c[1];
    var click = function () { return (util_1.state.clicked = index === clicked ? null : index); };
    var over = function () { return hover(true); };
    var out = function () { return hover(false); };
    (0, fiber_1.useFrame)(function (state, delta) {
        var y = scroll.curve(
        // eslint-disable-next-line react/prop-types
        index / urls.length - 1.5 / urls.length, 
        // eslint-disable-next-line react/prop-types
        4 / urls.length);
        // @ts-expect-error
        ref.current.material.scale[1] = ref.current.scale.y = (0, util_1.damp)(
        // @ts-expect-error
        ref.current.scale.y, clicked === index ? 5 : 4 + y, 8, delta);
        // @ts-expect-error
        ref.current.material.scale[0] = ref.current.scale.x = (0, util_1.damp)(
        // @ts-expect-error
        ref.current.scale.x, clicked === index ? 4.7 : scale[0], 6, delta);
        if (clicked !== null && index < clicked) {
            // @ts-expect-error
            ref.current.position.x = (0, util_1.damp)(
            // @ts-expect-error
            ref.current.position.x, position[0] - 2, 6, delta);
        }
        if (clicked !== null && index > clicked) {
            // @ts-expect-error
            ref.current.position.x = (0, util_1.damp)(
            // @ts-expect-error
            ref.current.position.x, 
            // eslint-disable-next-line @typescript-eslint/restrict-plus-operands
            position[0] + 2, 6, delta);
        }
        if (clicked === null || clicked === index) {
            // @ts-expect-error
            ref.current.position.x = (0, util_1.damp)(
            // @ts-expect-error
            ref.current.position.x, position[0], 6, delta);
        }
        // @ts-expect-error
        ref.current.material.grayscale = (0, util_1.damp)(
        // @ts-expect-error
        ref.current.material.grayscale, hovered || clicked === index ? 0 : Math.max(0, 1 - y), 6, delta);
        // @ts-expect-error
        ref.current.material.color.lerp(c.set(hovered || clicked === index ? 'white' : '#aaa'), hovered ? 0.3 : 0.1);
    });
    return (
    // @ts-expect-error
    react_1.default.createElement(drei_1.Image, __assign({ ref: ref }, props, { position: position, scale: scale, onClick: click, onPointerOver: over, onPointerOut: out })));
};
// eslint-disable-next-line react/prop-types
var Items = function (_a) {
    var urls = _a.urls, _b = _a.w, w = _b === void 0 ? 0.7 : _b, _c = _a.gap, gap = _c === void 0 ? 0.15 : _c;
    var width = (0, fiber_1.useThree)(function (state) { return state.viewport; }).width;
    var xW = w + gap;
    return (react_1.default.createElement(drei_1.ScrollControls, { horizontal: true, damping: 10, 
        // eslint-disable-next-line react/prop-types
        pages: (width - xW + urls.length * xW) / width },
        react_1.default.createElement(Minimap_1.Minimap, { urls: urls }),
        react_1.default.createElement(drei_1.Scroll, null, urls.map(function (url, i) { return (react_1.default.createElement(Item, { key: i, index: i, position: [i * xW, 0, 0], scale: [w, 4, 1], url: url, urls: urls })); }))));
};
var ThreeSlider = function (props) { return (react_1.default.createElement(fiber_1.Canvas, { gl: { antialias: false }, dpr: [1, 1.5], onPointerMissed: function () { return (util_1.state.clicked = null); } },
    react_1.default.createElement(Items, { urls: props.urls }))); };
exports.default = ThreeSlider;
