"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Minimap = void 0;
var THREE = __importStar(require("three"));
var react_1 = __importStar(require("react"));
var fiber_1 = require("@react-three/fiber");
var drei_1 = require("@react-three/drei");
var util_1 = require("./util");
var material = new THREE.LineBasicMaterial({ color: 'white' });
var geometry = new THREE.BufferGeometry().setFromPoints([
    new THREE.Vector3(0, -0.5, 0),
    new THREE.Vector3(0, 0.5, 0)
]);
function Minimap(props) {
    var ref = (0, react_1.useRef)();
    var scroll = (0, drei_1.useScroll)();
    var height = (0, fiber_1.useThree)(function (state) { return state.viewport; }).height;
    (0, fiber_1.useFrame)(function (state, delta) {
        // @ts-expect-error
        ref.current.children.forEach(function (child, index) {
            // Give me a value between 0 and 1
            //   starting at the position of my item
            //   ranging across 4 / total length
            //   make it a sine, so the value goes from 0 to 1 to 0.
            var y = scroll.curve(index / props.urls.length - 1.5 / props.urls.length, 4 / props.urls.length);
            child.scale.y = (0, util_1.damp)(child.scale.y, 0.1 + y / 6, 8, delta);
        });
    });
    return (react_1.default.createElement("group", { ref: ref }, props.urls.map(function (_, i) { return (react_1.default.createElement("line", { key: i, 
        // @ts-expect-error
        geometry: geometry, material: material, position: [i * 0.06 - props.urls.length * 0.03, -height / 2 + 0.6, 0] })); })));
}
exports.Minimap = Minimap;
