var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as THREE from 'three';
import React, { useRef, useState } from 'react';
import { Canvas, useFrame, useThree } from '@react-three/fiber';
import { Image, ScrollControls, Scroll, useScroll } from '@react-three/drei';
import { useSnapshot } from 'valtio';
import { Minimap } from './utils/Minimap';
import { state, damp } from './utils/util';
var Item = function (_a) {
    var 
    // eslint-disable-next-line react/prop-types
    urls = _a.urls, 
    // eslint-disable-next-line react/prop-types
    index = _a.index, 
    // eslint-disable-next-line react/prop-types
    position = _a.position, 
    // eslint-disable-next-line react/prop-types
    scale = _a.scale, 
    // eslint-disable-next-line react/prop-types
    _b = _a.c, 
    // eslint-disable-next-line react/prop-types
    c = _b === void 0 ? new THREE.Color() : _b, props = __rest(_a, ["urls", "index", "position", "scale", "c"]);
    var ref = useRef();
    var scroll = useScroll();
    var clicked = useSnapshot(state).clicked;
    var _c = useState(false), hovered = _c[0], hover = _c[1];
    var click = function () { return (state.clicked = index === clicked ? null : index); };
    var over = function () { return hover(true); };
    var out = function () { return hover(false); };
    useFrame(function (state, delta) {
        var y = scroll.curve(
        // eslint-disable-next-line react/prop-types
        index / urls.length - 1.5 / urls.length, 
        // eslint-disable-next-line react/prop-types
        4 / urls.length);
        // @ts-expect-error
        ref.current.material.scale[1] = ref.current.scale.y = damp(
        // @ts-expect-error
        ref.current.scale.y, clicked === index ? 5 : 4 + y, 8, delta);
        // @ts-expect-error
        ref.current.material.scale[0] = ref.current.scale.x = damp(
        // @ts-expect-error
        ref.current.scale.x, clicked === index ? 4.7 : scale[0], 6, delta);
        if (clicked !== null && index < clicked) {
            // @ts-expect-error
            ref.current.position.x = damp(
            // @ts-expect-error
            ref.current.position.x, position[0] - 2, 6, delta);
        }
        if (clicked !== null && index > clicked) {
            // @ts-expect-error
            ref.current.position.x = damp(
            // @ts-expect-error
            ref.current.position.x, 
            // eslint-disable-next-line @typescript-eslint/restrict-plus-operands
            position[0] + 2, 6, delta);
        }
        if (clicked === null || clicked === index) {
            // @ts-expect-error
            ref.current.position.x = damp(
            // @ts-expect-error
            ref.current.position.x, position[0], 6, delta);
        }
        // @ts-expect-error
        ref.current.material.grayscale = damp(
        // @ts-expect-error
        ref.current.material.grayscale, hovered || clicked === index ? 0 : Math.max(0, 1 - y), 6, delta);
        // @ts-expect-error
        ref.current.material.color.lerp(c.set(hovered || clicked === index ? 'white' : '#aaa'), hovered ? 0.3 : 0.1);
    });
    return (
    // @ts-expect-error
    React.createElement(Image, __assign({ ref: ref }, props, { position: position, scale: scale, onClick: click, onPointerOver: over, onPointerOut: out })));
};
// eslint-disable-next-line react/prop-types
var Items = function (_a) {
    var urls = _a.urls, _b = _a.w, w = _b === void 0 ? 0.7 : _b, _c = _a.gap, gap = _c === void 0 ? 0.15 : _c;
    var width = useThree(function (state) { return state.viewport; }).width;
    var xW = w + gap;
    return (React.createElement(ScrollControls, { horizontal: true, damping: 10, 
        // eslint-disable-next-line react/prop-types
        pages: (width - xW + urls.length * xW) / width },
        React.createElement(Minimap, { urls: urls }),
        React.createElement(Scroll, null, urls.map(function (url, i) { return (React.createElement(Item, { key: i, index: i, position: [i * xW, 0, 0], scale: [w, 4, 1], url: url, urls: urls })); }))));
};
var ThreeSlider = function (props) { return (React.createElement(Canvas, { gl: { antialias: false }, dpr: [1, 1.5], onPointerMissed: function () { return (state.clicked = null); } },
    React.createElement(Items, { urls: props.urls }))); };
export default ThreeSlider;
